# Class LocalDate

java.lang.Object
java.time.LocalDate

All Implemented Interfaces:
  `Comparable<LocalDate>, TemporalAccessor`

public final class LocalDate extends Object implements Comparable<LocalDate>, TemporalAccessor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ZonedDateTime`
  `atStartOfDay(ZoneId zone)`
  `LocalDateTime`
  `atTime(int hour, int minute)`
  `LocalDateTime`
  `atTime(int hour, int minute, int second)`
  `LocalDateTime`
  `atTime(int hour, int minute, int second, int nano)`
  `LocalDateTime`
  `atTime(LocalTime time)`
  `int`
  `compareTo(LocalDate other)`
  Compares this object to the specified object to determine their relative order.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `String`
  `format(DateTimeFormatter formatter)`
  `int`
  `getDayOfMonth()`
  `int`
  `getMonthValue()`
  `int`
  `getYear()`
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `boolean`
  `isLeapYear()`
  `int`
  `lengthOfMonth()`
  `LocalDate`
  `minusDays(long daysToSubtract)`
  `static LocalDate`
  `now()`
  `static LocalDate`
  `now(Clock clock)`
  `static LocalDate`
  `of(int year, int month, int dayOfMonth)`
  `static LocalDate`
  `ofEpochDay(long epochDay)`
  `static LocalDate`
  `parse(CharSequence text)`
  `static LocalDate`
  `parse(CharSequence text, DateTimeFormatter formatter)`
  `LocalDate`
  `plusDays(long daysToAdd)`
  `LocalDate`
  `plusMonths(long monthsToAdd)`
  `LocalDate`
  `plusYears(long yearsToAdd)`
  `long`
  `toEpochDay()`
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  `final Class`
  `getClass()`
  Returns the runtime class of an object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes current thread to wait until another thread invokes the method or the method for this object.
  `final void`
  `wait(long timeout)`
  Causes current thread to wait until either another thread invokes the method or the method for this object, or a specified amount of time has elapsed.
  `final void`
  `wait(long timeout, int nanos)`
  Causes current thread to wait until another thread invokes the method or the method for this object, or some other thread interrupts the current thread, or a certain amount of real time has elapsed.

- ## Method Details

  - ### now

    public static LocalDate now()

  - ### now

    public static LocalDate now(Clock clock)

  - ### of

    public static LocalDate of(int year, int month, int dayOfMonth)

  - ### ofEpochDay

    public static LocalDate ofEpochDay(long epochDay)

  - ### parse

    public static LocalDate parse(CharSequence text)

  - ### parse

    public static LocalDate parse(CharSequence text, DateTimeFormatter formatter)

  - ### getYear

    public int getYear()

  - ### getMonthValue

    public int getMonthValue()

  - ### getDayOfMonth

    public int getDayOfMonth()

  - ### isLeapYear

    public boolean isLeapYear()

  - ### lengthOfMonth

    public int lengthOfMonth()

  - ### toEpochDay

    public long toEpochDay()

  - ### plusDays

    public LocalDate plusDays(long daysToAdd)

  - ### plusMonths

    public LocalDate plusMonths(long monthsToAdd)

  - ### plusYears

    public LocalDate plusYears(long yearsToAdd)

  - ### minusDays

    public LocalDate minusDays(long daysToSubtract)

  - ### atTime

    public LocalDateTime atTime(int hour, int minute)

  - ### atTime

    public LocalDateTime atTime(int hour, int minute, int second)

  - ### atTime

    public LocalDateTime atTime(int hour, int minute, int second, int nano)

  - ### atTime

    public LocalDateTime atTime(LocalTime time)

  - ### atStartOfDay

    public ZonedDateTime atStartOfDay(ZoneId zone)

  - ### format

    public String format(DateTimeFormatter formatter)

  - ### compareTo

    public int compareTo(LocalDate other)
    Description copied from interface: `Comparable`
    Compares this object to the specified object to determine their relative order.
    Specified by:
      `compareTo` in interface `Comparable<LocalDate>`
    Parameters:
      `other` - the object to compare to this instance.
    Returns:
      a negative integer if this instance is less than `another`; a positive integer if this instance is greater than `another`; 0 if this instance has the same order as `another`.

  - ### equals

    public boolean equals(Object obj)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`